﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    WinJS.UI.Pages.define("/input.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            // TODO: Initialize the page here.
            var btnAddRun = document.getElementById("btnAddRun");
            if (null != btnAddRun)
                btnAddRun.addEventListener("click", btnAddRun_Click, false);

            var btnSelectPhoto = document.getElementById("btnSelectPhoto");
            if (null != btnSelectPhoto)
                btnSelectPhoto.addEventListener("click", btnSelectPhoto_Click, false);

        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });

    function btnAddRun_Click(e) {
        var facebookOauthUrl = "https://www.facebook.com/dialog/oauth";
        var facebookClientId = "[YOUR CLIENT ID]";
        var redirectUrl = "https://www.facebook.com/connect/login_success.html";

        var requestUri = Windows.Foundation.Uri(facebookOauthUrl +
        "?client_id=" + facebookClientId +
        "&redirect_uri=" + encodeURIComponent(redirectUrl) +
        "&response_type=" +
        "token&scope=read_stream,publish_actions&display=popup");

        var callbackUri = Windows.Foundation.Uri(redirectUrl);
        Windows.Security.Authentication.Web.WebAuthenticationBroker.
            authenticateAsync(Windows.Security.Authentication.Web.
            WebAuthenticationOptions.none, requestUri, callbackUri)
            .done(
            function (result) {
                switch (result.responseStatus) {
                    case Windows.Security.Authentication.Web.WebAuthenticationStatus.success:
                        var fragment = Windows.Foundation.Uri(result.responseData).fragment;
                        if (fragment.indexOf("#access_token=") != -1) {
                            var token = fragment.substring(
                            new String("#access_token=").length,
                            fragment.indexOf("&expires_in="));
                            // Add API calls here
                            var fileBlob = MSApp.createBlobFromRandomAccessStream(
                                selectedPhotoFile.contentType,
                                selectedPhotoStream);

                            var message = "I just ran " + document.getElementById("txtDistance").value + " miles with PhotoFinish! " + document.getElementById("txtComment").value;

                            var data = new FormData();
                            data.append("source", fileBlob);
                            data.append("filename", selectedPhotoFile.name);
                            data.append("access_token", token);
                            data.append("message", window.toStaticHTML(message));

                            WinJS.xhr({
                                type: "POST",
                                url: "https://graph.facebook.com/me/photos",
                                data: data,
                            }).then(
                              function (photoid_response) {
                                  var resp = photoid_response;
                                  //ProcessResponse(photoid_response);
                              },
                              function (ex) {
                                  var err = ex;
                                  //Display("An error occurred while posting the photo.");
                                  //Log(ex);
                              });
                        }
                        break;
                    case Windows.Security.Authentication.Web.WebAuthenticationStatus.userCancel:
                        //Log(window.toStaticHTML(result.responseData));
                        //Display("User cancelled the authentication to Facebook.");
                        break;
                    case Windows.Security.Authentication.Web.WebAuthenticationStatus.errorHttp:
                        //Log(window.toStaticHTML(result.responseData));
                        //Display("An error occurred while communicating with Facebook.");
                        break;
                }
            },
            function (ex) {
                //Log(ex);
            }
        );
    }

    function btnSelectPhoto_Click(e) {
        var imgSelectedPhoto = document.getElementById("imgSelectedPhoto");

        var filePicker = new Windows.Storage.Pickers.FileOpenPicker();
        filePicker.fileTypeFilter.replaceAll([".jpg", ".jpeg", ".png"]);
        filePicker.suggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.picturesLibrary;
        filePicker.viewMode = Windows.Storage.Pickers.PickerViewMode.thumbnail;

        //pick file here
        filePicker.pickSingleFileAsync().then(
            function (storageFile) {
              if (storageFile) {
                  selectedPhotoFile = storageFile;
                  selectedPhotoFile.openAsync(Windows.Storage.FileAccessMode.read).then(
                  function (stream) {
                      selectedPhotoStream = stream;
                      document.getElementById("imgSelectedPhoto").src = URL.createObjectURL(selectedPhotoFile);
                  },
                  function (ex) {
                      var err = ex;
                      //Log(ex);
                      //Display("An error has occurred while reading the file.");
                  });
              }
              else {
                  //Display("File was not selected");

              }
        });
    }
})();

